<?

node_include("core_file");

function getMultiFileUploader($folderID) {

 global $MAX_FILESIZE,$DIC, $PORTLETAPP_PREFIX, $FEATURE, $SESSION_SECRET, $NODE_ID, $SESSION_SECRET_COOKIE_NAME, $SID;

 $nodeid = $NODE_ID;
 
 
 
 if (!isset($nodeid) && isset($folderID)) {
 $folderinfo = get_folderinfo($folderID);
 $nodeid = $folderinfo["node_id"];
 }
 
 $flashCondition = $FEATURE['alwaysfileuploadfallback'] ? "false" : "jQuery.browser.flash";

 $scriptFolderID = ((isSet($folderID) && $folderID != null) ? $folderID : "undefined");
 $output = "";
 $output .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"".core_file("lib/css/fileupload.css")."\"/>\n";
 $output .= "<script type=\"text/javascript\" language=\"JavaScript\" src=\"".core_file("lib/js/jquery.uploadify-3.1.min.js")."\"></script>\n";
 $output .= "<script type=\"text/javascript\" language=\"JavaScript\" src=\"".core_file("lib/js/fileuploader.js")."\"></script>\n";
 $output .= "<script type=\"text/javascript\" language=\"JavaScript\" src=\"".core_file("lib/js/jquery.jqplugin.1.0.3.js")."\"></script>\n";
 $output .= "<script type=\"text/javascript\">
			
	// i18n error messages
	var msgs = new Array();
	msgs['upload_limit_reached'] = \"". addslashes(i18n("upload_limit_reached"))."\";
	msgs['upload_permissions_missing'] = \"".addslashes(i18n("upload_permissions_missing"))."\";
	msgs['upload_folderid_missing'] = \"" . addslashes(i18n("upload_folderid_missing")). "\";
	msgs['upload_error'] = \"" . addslashes(i18n("upload_error")) . "\";
	msgs['upload_success'] = \"" . addslashes(i18n("upload_success")) . "\";
	msgs['upload_filename_error'] = \"" . addslashes(i18n("invalid_filename")) . "\";
	";

 if ( ! $FEATURE['alwaysfileuploadfallback'] ) {
 
 
 
 
 
 
 
 $output .= "
	function genticsFlashUploadify() {
		$(\"#uploadify\").uploadify({
				'swf'				: '". core_file("lib/js/uploadify.swf") ."',
				'uploader'			: '". $PORTLETAPP_PREFIX ."rest/file/create.json',
				'cancelImage'		: '?do=11&module=content&img=remove.png',
				'buttonImage'		: '?do=15&text=".i18n('uploadfile') ."',
				'width'				: 132,
				'height'			: 24,
				'fileObjName'		: 'fileBinaryData',
				'formData'			: { folderId: " . (($scriptFolderID != "undefined") ? $scriptFolderID : "''") . ", nodeId: " . $nodeid . ", sid: ". $SID. ", ".$SESSION_SECRET_COOKIE_NAME.": '". $SESSION_SECRET ."' },
				'auto'				: true,
				'queueID'			: 'fileQueue', 
				'fileSizeLimit'		: '" . filesize2bytes($MAX_FILESIZE) . "B',
				'onComplete'		: handleOnComplete,
				'onError'			: handleOnError,
				'onSelect'			: handleOnSelect,
				'onDialogOpen'		: handleOnDialogOpen,
				'onSelectError'		: handleOnSelectError,
				'removeCompleted'	: false,
				'overrideEvents'	: ['onSelectError'], 
				'removeTimeout'		: 10,
				'onAllComplete'		: handleOnAllComplete,
				'multi'				: true
		});
	}";
 }

 $output .= "
	function genticsJsUploadify() {
		// Hide the flash filequeue
		$('#fileQueue').hide();
		
		var fileName;
		var uploader;

		function handleSubmit(id, fileName) {
			var params =  { 'qqfile': fileName, 'filter-contenttype': 'text/html', folderId: " . $scriptFolderID . " , nodeId: " . $nodeid . " ,sid: '" . $_GET['sid'] . "' };
			uploader.setParams(params);
		}

		uploader = new qq.FileUploader({
				element: document.getElementById('noflashupload'),
				action: '". $PORTLETAPP_PREFIX ."rest/file/createSimple.json',
				
				template: '<div class=\"qq-uploader\">' + 
					  '<div class=\"qq-upload-drop-area\"><span>Drop files here to upload</span></div>' +
					  '<div class=\"qq-upload-button\"><img src=\"?do=15&text=" . i18n("uploadfile") . "\"></div>' +
					  '<ul class=\"qq-upload-list\"></ul>' + 
					  '</div>',

				// template for one item in file list
	        	fileTemplate: '<li>' +
	                '<span class=\"qq-upload-file\"></span>' +
	                '<span class=\"qq-upload-spinner\"></span>' +
	                '<span class=\"qq-upload-size\"></span>' +
	                '<a class=\"qq-upload-cancel\" href=\"#\">Cancel</a>' +
	                '<span class=\"qq-upload-failed-text\">Failed</span>' +
	            	'</li>',

				onSubmit: handleSubmit,
	
				messages: {
						serverError: msgs['upload_error'],
						typeError: \"{file} \" + msgs['upload_invalid_extension']  + \"has an invalid extension. Only {extensions} are allowed.\",
						sizeError: msgs['upload_limit_reached'],
						emptyError: \"{file} is empty. You can't upload empty files.\"
					},
				onComplete: function(id, fileName, responseJSON) {
					 	handleJSONResponse(responseJSON); 
				},
				sizeLimit: " . filesize2bytes($MAX_FILESIZE) . "
		});
		
	
		
		
	}";

 $output .= "
		$(document).ready(function() {
			if (" . $flashCondition . ") {
				genticsFlashUploadify();
			} else {
				genticsJsUploadify();
			}
	});
			 
			
		function handleOnError(event, queueID, fileObj, errorObj) {			
				if(errorObj.type == 'File Size') {
				if (window.console && console.error) {
					console.log(msgs['upload_limit_reached'] + 'Limit: " .$MAX_FILESIZE. "');
				}
			}
			else {
				alert(msgs['upload_error']);
			}
		}

		function handleOnSelectError(file, errorCode, errorMsg) {
			switch(errorCode) {
				case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
					this.queueData.errorMsg += '\\n' + file.name + ': " . addslashes(i18n("upload_limit_reached")) . " (" . filesize2bytes($MAX_FILESIZE) . " bytes).';
				break;
				case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
					this.queueData.errorMsg += '\\n' + file.name + ': " . addslashes(i18n("upload_error")) . "';
				break;
			}
	
		}
		
		function handleOnDialogOpen() {
			this.queueData.errorMsg='" . addslashes(i18n("upload_error")) . "';
		}

		//Show the queue once a file was selected
		function handleOnSelect(event,queueID,fileObj) {
			$('#fileQueue').slideDown('fast');
		}
		
		function handleOnComplete(event, queueID, fileObj, response, data) {
			var json = jQuery.parseJSON(response);
			handleJSONResponse(json);
		}
				
		function handleJSONResponse(json) {
			if(json.responseInfo.responseCode != 'OK') {
				// Check if the reponseMessage has a localized version
				if( msgs[json.responseInfo.responseMessage] != undefined ) {
					alert(msgs[json.responseInfo.responseMessage]);
					if (window.console && console.error) {
						console.log('Upload Error: ' + json.messages[0].message);
					}
				} else {
					alert( json.messages[0].message);
					if (window.console && console.error) {
						console.log('Upload Error:' + json.responseInfo.responseMessage);
					}	
				}
			}
		} 

		function handleOnAllComplete(event,data) {
			if(data.errors==0) {
				//alert(msgs['upload_success']);
				$('.cancel').hide('slow');
			} 

		}	
		</script>";
 $style = (isSet($folderID) && $folderID != null) ? "" : "display: none";
 $output .= "<br/><br/> <div id=\"noflashupload\" style=\"$style\" >
		<input class=\"uploadify\" id=\"uploadify\" name=\"uploadify\" type=\"file\" />
		<div id=\"fileQueue\" style=\"display: none\"></div><br/></div>";
 
 return $output; 
}



?>
