<?php 

class DupNameChecker
{
 function check( &$form )
 {
 $c = &$form->getComponent( "name" );
 $name = $c->getText();
 $hc = &$form->getComponent( "id" );
 $id = $hc->getValue();
 node_class( "sqltable" );
 $taskTable = new SqlTable( "task" );
 $results = $taskTable->findBy( "name", $name, "like" );
 if ( count( $results ) )
 {
 if ( $results[0]->getValue( "id" ) != $id )
 $c->addError( new NodeException( i18n( "Ein Task mit diesem Namen existiert bereits!" ) ) );
 }
 }
}
$NODE_CLASS["dupnamechecker"] = FALSE;

function actionOk( &$form, $param )
{
 global $REDO;
 $REDO = 860; 
 
 
 $result = $param["result"];
 $task = $param["task"];

 
 
 $nameComp = &$form->getComponent( "name" );

 $name = $nameComp->getText();
 $task->setValue( "name", $name );
 $task->setValue( "editor", $USER_ID );
 $task->setValue( "edate", time() );
 $task->save();

 foreach ( $result as $r )
 {
 $tplParam = $r["tasktemplateparam"];
 $param = $r["taskparam"];
 $pName = $tplParam->getValue("name");
 $key = $param->getValue("name");
 $comp = &$form->getComponent( $pName );
 if ( is_a( $comp, "collectioncomponent" ) )
 $val = $comp->resolveFieldValue( $key );
 else
 $val = $comp->getFieldValue( $key );
 
 $param->setValue( "value", $val );
 $param->save();
 }
}
 
function actionCancel( &$form, $param )
{
 global $REDO;
 $REDO = 860;
}
 
load_menu( 862, $T_TASK, $id, i18n('edit') );
node_include( "htmlform3" );
$form = new HtmlForm3( "taskedit" );

if ( $form->isNew() )
{
 if ( !$id )
 halt( 7, "task_edit.php: Invalid Task-ID" );
 node_class( "textcomponent" );
 node_class( "hiddencomponent" );
 node_class( "sqltable" );
 $taskTable = new SqlTable( "task" );
 $joinTable = new SqlJoinTable( array( $taskTable, new SqlTable( "taskparam" ), new SqlTable( "tasktemplateparam" ) ),
 array( "taskparam.task_id=task.id", "taskparam.templateparam_id=tasktemplateparam.id" ) );
 
 $result = $joinTable->findBy( "task.id", $id );
 $task = $result[0]["task"];
 if ( !is_object( $task ) )
 {
 $task = $taskTable->findBy( "id", $id );
 $task = $task[0]; 
 }
 $name = $task->getValue( "name" );

 $form->addComponent( "name", new TextComponent( i18n( "Name" ), TRUE, $name ) );
 $hash = hashParams( $result );
 foreach ( $hash as $cid=>$param )
 {
 $form->addComponent( $cid, $hash[$cid] );
 }
 $form->addComponent( "id", new HiddenComponent( $id ) );
 $form->addCustomCheck( new DupNameChecker() );
 $form->setHeader( i18n('sn_task_edit'), $ICO_TREEMENU );
 if ( perm( $USER_ID, T_TASKADMIN, "", 11) ) 
 $form->addButton( "ok", new Button( i18n( "OK" ) ), new SimpleFormAction( "actionOk", 
 array("result"=>$result, "task"=>$task) ), TRUE );
 $form->addButton( "hallo", new Button( i18n( "Cancel" ) ), new SimpleFormAction( "actionCancel" ) );
}


?>
