<?
if ($cmd == 'update' || $cmd == 'getprogress' || $cmd == "autoupdate") {
 GUIFactory::setMainGUI( "shell" );
} else {
 GUIFactory::setMainGUI( "main" );
 $maingui = &GUIFactory::getMainGUI();
 $maingui->includeJS( "jquery-1.6.1.min" );
 $maingui->includeJS("GTXAutoUpdateStatus");
 $maingui->includeJS("GTXScheduler");
 $maingui->includeJS("GTXBackgroundSequence");
}

if (perm($USER_ID, T_SELFUPDATE, '', 0) != 1 && $cmd != 'update' && $cmd != 'getprogress' && $cmd != "autoupdate") {
 halt(10003,"No permission to display auto updater.");
}

node_class("scheduler");

global $autoupdate;
$autoupdate = new AutoUpdate();
$autoupdate->checkDirectories();




function startUpdate($form) {
 global $autoupdate, $UPDATE_FROM_LOCAL;

 if (!$UPDATE_FROM_LOCAL) {
 
 $mup = $form->resolveComponent("main.updateversion");
 $selectedVersion = $mup->getSingleSelection();
 $autoupdate->setSelectedUpdateFilenameByVersion(parse_version($selectedVersion));
 } else {
 $autoupdate->setSelectedUpdateFilename($autoupdate->getLatestLocalUpdateFilename());
 }
 $autoupdate->setRunUpdateFlag(true);
}




function setUpdateVersion($form) {
 global $ICO_SELFUPDATE_ANI, $autoupdate;
 
 $mup = $form->resolveComponent("main.updateversion");
 $selectedVersionValue = $mup->getSingleSelection();
 $selectedVersion = parse_version($selectedVersionValue);
 $autoupdate->setSelectedUpdateFilenameByVersion($selectedVersion);
 $updateFilename = $autoupdate->getSelectedUpdateFilename();

 $startupdate = $form->getButton("startupdate");
 if ($startupdate) {
 $isNewerUpdate = compare_gcnversion($selectedVersion, get_current_gcnversion()) == 1;
 $startupdate->setEnabled($isNewerUpdate);
 }
}






function setVersionSelectionOptions($versionSelectionComp) {
 global $autoupdate;
 
 $options = array();
 $versions = $autoupdate->getAllAvailableVersionsFromUpdatesite();
 foreach ($versions as $version) {
 $options[$version['name']] = $version['name']; 
 }
 
 if (count($versions) > 0) {
 $versionSelectionComp->setOptions($options);
 }
}




function displayUpdateProgress($form) {
 global $STAG, $DO;
 header("Location: $STAG&do=$DO&cmd=updateprogress");
}




if ($im && $msg && $imto && $FEATURE["instantmessages"] && perm($USER_ID, T_INBOX, "", 2)) {

 
 if (!msg_interactive($msg, $imto, $USER_ID, 5) ) {
 $JS .= global_validation_error_js_alert();
 }

 $instantMessageSent = true;
}

if ($maintenanceMode && $FEATURE["maintenance_mode"] && perm($USER_ID, $T_MAINTENANCE, "", 1)) {
 if ($maintenanceMode === "enable") {
 setMaintenanceMode(true);
 } else {
 setMaintenanceMode(false);
 }
}

$cmd = $autoupdate->handleCommand($cmd);




node_class('htmlform3');
$form = new HtmlForm3("selfupdate");
if ($form->isNew()) {

 $updateFilename = $autoupdate->getSelectedUpdateFilename();
 node_class("listcomponent");
 node_class("textcomponent");
 node_class("labelcomponent");
 node_class("selectcomponent");

 $main = new ListComponent();

 
 if ($UPDATE_FROM_LOCAL) {
 $updatefromlocal = new LabelComponent(i18n("Update From Local"), $UPDATE_FROM_LOCAL);
 $main->setComponent("updatefromlocal", $updatefromlocal);
 }

 
 $current = get_current_gcnversion();
 $curversion = new LabelComponent( i18n("Current Version"), prettyprint_gcnversion($current));
 $main->setComponent('curversion', $curversion);

 
 $verText = $autoupdate->getLastestVersionLabelHTML();
 $latestVersion = $autoupdate->getLatestVersion();
 if (compare_gcnversion($latestVersion, $current) === 1) {
 $verText .= ' <img src="' . $ICO_SELFUPDATE_ANI . '" style="margin-bottom: -4px;" alt="' . i18n('Update available') . '" title="' . i18n('Update available') . '">';
 }
 
 $latestversionLabel = new LabelComponent(i18n("Latest Version"), $verText, true);
 $main->setComponent('latestversion', $latestversionLabel);
 
 
 $updateRunning = AutoUpdateStatus::isUpdateRunning();
 if ($updateRunning) {
 $btntxt = i18n("display_update_progress");
 } else {
 $btntxt = i18n("download_update");
 }
 $startUpdateButton = new Button($btntxt);
 
 if (!$latestVersion || compare_gcnversion($latestVersion, $current) < 1) {
 $startUpdateButton->setEnabled(false);
 }

 
 if (!$UPDATE_FROM_LOCAL && $latestVersion) {
 $versionSelectionComp = new SelectComponent(i18n("update_target_label"));
 $versionSelectionComp->setAllowEmpty(false);
 $versionSelectionComp->setOnChangeAction(new SimpleFormAction("setUpdateVersion"));
 $main->setComponent('updateversion', $versionSelectionComp);
 setVersionSelectionOptions($versionSelectionComp);
 $suggestedUpdateVersion = $autoupdate->getSuggestedUpdateVersionForCurrentVersion();
 if (!is_null($suggestedUpdateVersion)) {
 $versionSelectionComp->setSelection($suggestedUpdateVersion['name']);
 }
 }
 
 if ($updateRunning) {
 $main->setComponent("update_in_progress_info", 
 new LabelComponent("<img src=\"$ICO_INFO\">", i18n("update_in_progress_info"))
 );
 $form->addButton("display_update_progress", $startUpdateButton, new SimpleFormAction("displayUpdateProgress"), true);
 } else {
 $form->addButton("startupdate", $startUpdateButton, new SimpleFormAction("startUpdate"), true);
 }
 $form->setHeader(i18n("Update"), $ICO_USER);
 $form->addComponent('main', $main);
}

node_class("sqldatasource");
node_class("itemlist3");


if (!$showlog) {
 
 $select = "a.date, a.updatefile, a.status, CONCAT(u.firstname, ' ', u.lastname) user ";
 $from = "autoupdatelog a LEFT JOIN systemuser u ON a.user_id = u.id";
 $where = "1=1 ORDER BY a.date DESC";
 $ds = new SQLDatasource( "autoupdatelog", $select, $from, $where );
 $ds->setDBHandle($DB);
 $ds->addColumn( "date", i18n("date"), true, false );
 $ds->addColumn( "updatefile", "Version", true, false );
 $ds->addColumn( "user", i18n("user"), true, false );
 $ds->addColumn( "status", i18n("status"), true, false );
 $ds->addColumn( "log", "Log", true, false );
 $ds->addFormatter("log", new UpdateLogFormatter());
 $ds->addFormatter("status", new UpdateStatusFormatter());
 $ds->addFormatter("updatefile", new UpdateFileFormatter());
 $ds->addFormatter("user", new UserFormatter());
 $ds->setDefaultSort("date","DESC");
 
 
 $updatelog = new ItemList3("logerror",$ds);
 $updatelog->setNoHeader(true);
 $updatelog->setShowInfo(true);
 
 $updatefiles = $autoupdate->getDownloadedUpdateFiles();
}

?>