<?php








function load_related( $r, $viewsTitle=false, $activeView=false )
{
 global $CONTENTGROUP_ID, $FEATURE;

 if ( !is_array( $r ) )
 return;
 
 global $JS, $DIC, $USER_ID, $PAGELIST_COUNT, $FILELIST_COUNT, $IMAGELIST_COUNT, $FOLDERLIST_COUNT, $TEMPLATELIST_COUNT, $T_PAGE, $T_FILE, $T_IMAGE, $T_FOLDER, $T_TEMPLATE;
 $html = "";
 $title = i18n('help');
 $count = 0;

 foreach ( $r as $rel ) {
 if(! is_array($rel) ) continue;
 $allowed = true;
 $perms = $rel["perms"];
 if ( is_array( $perms ) )
 {
 if( $perms['role_bit'] ) {
 $allowed = perm( $USER_ID, $perms["t_type"], $perms["o_id"], $perms["bit"], $CONTENTGROUP_ID, $perms["role_type"], $perms['role_bit'] );
 } else {
 $allowed = perm( $USER_ID, $perms["t_type"], $perms["o_id"], $perms["bit"] );
 }
 }

 if ( $allowed ) {

 $count ++;
 $icon = $rel["icon"];
 $link = addslashes($rel["link"]);
 $text = $rel["text"];
 $linktext = $rel["linktext"];
 $alttext = $text;
 $help = $rel["help"];
 $target = $rel["target"];
 $ttype = $rel['ttype'];
 $imgclass = '';
 $items = "";
 if( $ttype && is_array( $perms ) ) {
 if ($FEATURE["multichannelling"]) {
 $obj = &NodeFactory::getStaticInstanceOf( $perms['t_type'], $perms['o_id'] );
 $countFromREST = $obj->getObjectCount( $ttype );

 
 if($rel['ttype'] == $T_PAGE && isset($PAGELIST_COUNT)) {
 $countFromREST = $PAGELIST_COUNT;
 } else if ($rel['ttype'] == $T_IMAGE && isset($IMAGELIST_COUNT)) {
 $countFromREST = $IMAGELIST_COUNT;
 } else if ($rel['ttype'] == $T_FILE && isset($FILELIST_COUNT)) {
 $countFromREST = $FILELIST_COUNT;
 } else if ($rel['ttype'] == $T_FOLDER && isset($FOLDERLIST_COUNT)) {
 $countFromREST = $FOLDERLIST_COUNT;
 } else if ($rel['ttype'] == $T_TEMPLATE && isset($TEMPLATELIST_COUNT)) {
 $countFromREST = $TEMPLATELIST_COUNT;
 }
 
 if ($countFromREST < 1) {
 $imgclass = 'gentics_icon_invisible';
 } else {
 $items = "&nbsp;($countFromREST)";
 }
 $alttext .= ' ' . i18n( '({0} Items)', 0, $countFromREST);
 } else {
 $obj = &NodeFactory::getStaticInstanceOf( $ttype );
 
 $res = $obj->searchInObject($perms['t_type'], $perms['o_id'], null, false, false, true);
 if(count($res) < 1) {
 $imgclass = 'gentics_icon_invisible';
 } else {
 $items = "&nbsp;(".count($res).")";
 }
 $alttext .= ' ' . i18n( '({0} Items)', 0, count($res));
 }
 }

 if ($viewsTitle) {
 if ($text == $activeView["text"]) {
 $class = ' class="active"';
 
 } else {
 $class = "";
 }
 $html .= "views += '<a href=\"$link\" target=\"$target\"$class>" . img($icon, 0, $alttext, '', '', '', '', '', $imgclass) . "<span>$linktext$items</span></a>';\n";
 } else {
 $html .= "related += '<span ' +";
 if ( in_array( $target, array( "list", "tree", "menu" ) ) ) {
 $onclick = "onclick=\"progress(top.menu); return true;\"";
 } else { 
 $onclick = "";
 }
 $html .= "'><a target=\"$target\" href=\"$link\" $onclick>".img($icon, 0)." $text</a></span>';\n";
 }
 }
 }

 if ( $count > 0 ) {
 if ($viewsTitle) {
 $JS .= "
				var views = '';
				var viewsName = '$viewsTitle';
				$html;

				";
 } else {
 $JS .= "
				var related='';
				$html
				related += '';
				
				if ( parent.ass && parent.ass.ass_reset)
				{
					parent.ass.ass_reset();
					parent.ass.info();
				}";
 }
 }
}
?>